# Integration with React

The HyperFormula API is identical in a React app and in plain JavaScript. This guide demonstrates how HyperFormula is integrated with the React component tree and how its lifecycle maps to React hooks.

Install with npm install hyperformula. For other options, see the client-side installation section.

# Basic usage

Hold the HyperFormula instance in a useRef so it survives re-renders. Initialize it inside useEffect and release it in the cleanup function. Use useState to toggle between raw formulas and computed values.

import { useEffect, useRef, useState } from 'react';
import { HyperFormula } from 'hyperformula';
import type { CellValue } from 'hyperformula';

export default function SpreadsheetComponent() {
  const hfRef = useRef<HyperFormula | null>(null);
  const [values, setValues] = useState<CellValue[][]>([]);

  useEffect(() => {
    const hf = HyperFormula.buildFromArray(
      [
        [1, 2, '=A1+B1'],
        // your data rows go here
      ],
      {
        licenseKey: 'gpl-v3',
        // more configuration options go here
      }
    );
    hfRef.current = hf;

    return () => {
      hf.destroy();
      hfRef.current = null;
    };
  }, []);

  function runCalculations() {
    if (!hfRef.current) return;
    setValues(hfRef.current.getSheetValues(0));
  }

  function reset() {
    setValues([]);
  }

  return (
    <>
      <button onClick={runCalculations}>Run calculations</button>
      <button onClick={reset}>Reset</button>
      {values.length > 0 && (
        <table>
          <tbody>
            {values.map((row, r) => (
              <tr key={r}>
                {row.map((cell, c) => (
                  <td key={c}>{String(cell ?? '')}</td>
                ))}
              </tr>
            ))}
          </tbody>
        </table>
      )}
    </>
  );
}

If you use JavaScript instead of TypeScript, drop the type annotations — the rest of the pattern is unchanged.

# React.StrictMode double invocation

In development, React runs effects twice (mount → unmount → mount) to surface cleanup bugs. The pattern above is correct for StrictMode because destroy() runs before the re-mount creates a new instance, so no work leaks between the two lifecycles. Do not switch to a module-scoped singleton as a workaround — it will break StrictMode semantics.

# Server-side rendering (Next.js App Router)

The component above is already SSR-safe — the engine is constructed in useEffect, which never runs on the server. If you still want to skip the initial bundle on the server (it is a few hundred kB), wrap it in a client-only dynamic import.

In the App Router, dynamic(..., { ssr: false }) is only allowed inside a client component. Put the dynamic call in a 'use client' wrapper and import the wrapper from your server page:

// app/spreadsheet/SpreadsheetLazy.tsx
'use client';
import dynamic from 'next/dynamic';

const SpreadsheetComponent = dynamic(
  () => import('./SpreadsheetComponent'),
  { ssr: false }
);

export default function SpreadsheetLazy() {
  return <SpreadsheetComponent />;
}
// app/spreadsheet/page.tsx  ← server component, no 'use client'
import SpreadsheetLazy from './SpreadsheetLazy';

export default function Page() {
  return <SpreadsheetLazy />;
}

In the Pages Router, the same dynamic(..., { ssr: false }) call works directly in the page file without a wrapper.

# Next steps

# Demo

For a more advanced example, check out the React demo on Stackblitz.

# Integration with Svelte

The HyperFormula API is identical in a Svelte app and in plain JavaScript. This guide demonstrates how HyperFormula integrates with the Svelte component's lifecycle and how you bridge its values into Svelte's reactivity.

Install with npm install hyperformula. For other options, see the client-side installation section.

SvelteKit SSR

The primary snippet below assumes a browser environment. If you use SvelteKit with default SSR, skip to Server-side renderingHyperFormula.buildFromArray at <script> top level will run on every server render, which is unnecessary work.

# Basic usage

Declare the engine at the top of <script> so it lives for the component's lifetime. Call getCellValue on demand and display results in the template. Release the engine with onDestroy.

<script>
  import { onDestroy } from 'svelte';
  import { HyperFormula } from 'hyperformula';

  const data = [
    [1, 2, '=A1+B1'],
    // your data rows go here
  ];

  const hf = HyperFormula.buildFromArray(data, {
    licenseKey: 'gpl-v3',
    // more configuration options go here
  });

  const sheetId = 0;
  /** @type {import('hyperformula').CellValue} */
  let result = null;

  function calculate() {
    result = hf.getCellValue({ sheet: sheetId, row: 0, col: 2 });
  }

  function reset() {
    result = null;
  }

  onDestroy(() => hf.destroy());
</script>

<button on:click={calculate}>Run calculations</button>
<button on:click={reset}>Reset</button>
{#if result !== null}
  <p>Result: <strong>{result}</strong></p>
{/if}

<table>
  <tbody>
    {#each data as row, r}
      <tr>
        {#each row as cell, c}
          <td>
            {#if hf.doesCellHaveFormula({ sheet: sheetId, row: r, col: c })}
              {hf.getCellFormula({ sheet: sheetId, row: r, col: c })}
            {:else}
              {hf.getCellValue({ sheet: sheetId, row: r, col: c })}
            {/if}
          </td>
        {/each}
      </tr>
    {/each}
  </tbody>
</table>

# Server-side rendering (SvelteKit)

In SvelteKit, top-level statements in <script> run on the server too. HyperFormula has no browser-only API dependency, but instantiating it during SSR is wasted work. Move the initialization into onMount so it only runs on the client:

onMount is allowed to be async, but any cleanup function returned from an async callback is silently ignored — an async function always returns a Promise, not the cleanup. Put the teardown in a separate onDestroy instead:

<script>
  // Svelte 4 + SvelteKit
  import { onDestroy, onMount } from 'svelte';

  let hf;
  /** @type {import('hyperformula').CellValue} */
  let result = null;

  onMount(async () => {
    const { HyperFormula } = await import('hyperformula');
    hf = HyperFormula.buildFromArray(
      [
        [1, 2, '=A1+B1'],
        // your data rows go here
      ],
      { licenseKey: 'gpl-v3' }
    );
  });

  // Separate onDestroy — async onMount cannot return a cleanup.
  onDestroy(() => hf?.destroy());

  function calculate() {
    if (!hf) return;
    result = hf.getCellValue({ sheet: 0, row: 0, col: 2 });
  }

  function reset() {
    result = null;
  }
</script>

<button on:click={calculate}>Run calculations</button>
<button on:click={reset}>Reset</button>
{#if result !== null}
  <p>Result: <strong>{result}</strong></p>
{/if}

# Next steps

# Demo

For a more advanced example, check out the Svelte demo on Stackblitz.

# Integration with Vue
The HyperFormula API is identical in a Vue 3 app and in plain JavaScript. This guide demonstrates how HyperFormula integrates with the Vue reactivity system and how to surface its values in the template.
Install with npm install hyperformula. For other options, see the client-side installation section.
# Basic usage
Wrap the HyperFormula instance inside a plain class so it stays outside Vue's reactivity system (see Troubleshooting below for why this matters). Hold derived data in ref so the template updates when you reassign the ref's .value.
// spreadsheet-provider.ts
import { HyperFormula, type CellValue } from 'hyperformula';
export class SpreadsheetProvider {
private hf: HyperFormula;
constructor(data: (string | number | null)[][]) {
this.hf = HyperFormula.buildFromArray(data, {
licenseKey: 'gpl-v3',
// more configuration options go here
});
}
getCalculatedValues(): CellValue[][] {
return this.hf.getSheetValues(0);
}
getRawFormulas(): (string | number | null)[][] {
return this.hf.getSheetSerialized(0) as (string | number | null)[][];
}
destroy() {
this.hf.destroy();
}
}
Use the class from a component with <script setup>:
<script setup lang="ts">
import { onUnmounted, ref } from 'vue';
import type { CellValue } from 'hyperformula';
import { SpreadsheetProvider } from './spreadsheet-provider';
const provider = new SpreadsheetProvider([
[1, 2, '=A1+B1'],
// your data rows go here
]);
const values = ref<CellValue[][]>([]);
function runCalculations() {
values.value = provider.getCalculatedValues();
}
function reset() {
values.value = [];
}
onUnmounted(() => provider.destroy());
</script>
<template>
<button @click="runCalculations">Run calculations</button>
<button @click="reset">Reset</button>
<table v-if="values.length">
<tr v-for="(row, r) in values" :key="r">
<td v-for="(cell, c) in row" :key="c">{{ cell }}</td>
</tr>
</table>
</template>
The class keeps the HyperFormula instance as a private field, so Vue's reactivity Proxy never reaches it. This is the same pattern used in the Vue 3 demo.
# Server-side rendering (Nuxt)
The class above is already SSR-safe — HyperFormula has no browser-only API dependency. To skip the (otherwise wasted) server-side instantiation in Nuxt, wrap the component with <ClientOnly>.
# Troubleshooting
# Vue reactivity issues
If you encounter an error like
Uncaught TypeError: Cannot read properties of undefined (reading 'licenseKeyValidityState')
it means that Vue's reactivity system tried to deeply observe the HyperFormula instance. Vue wraps reactive objects in a Proxy that intercepts every property access; when that proxy reaches a non-trivial instance with its own internal state, identity checks and lazy-initialized maps break. The fix is to opt the instance out of reactivity with Vue's markRaw (opens new window):
import { markRaw } from 'vue';
import { HyperFormula } from 'hyperformula';
const hfInstance = markRaw(
HyperFormula.buildEmpty({
licenseKey: 'gpl-v3',
})
);
shallowRef is not a substitute: it skips proxying only at the top level, so writing the instance into a nested reactive structure (Pinia state, reactive({...})) will still wrap it. Always pass the instance itself through markRaw before putting it anywhere Vue can reach.
# Next steps
- Configuration options — full list of
buildFromArray/buildEmptyoptions - Basic operations — CRUD on cells, rows, columns, sheets
- Advanced usage — multi-sheet workbooks, named expressions
- Custom functions — register your own formulas
# Demo
For a more advanced example, check out the Vue 3 demo on Stackblitz.
TIP
This demo uses the Vue 3 (opens new window) framework. If you are looking for an example using Vue 2, check out the code on GitHub (opens new window).